=== debian/changelog ===
newsboat (2.21-1) unstable; urgency=medium

  * New upstream version 2.21
  * d/patches: Fix cargo.lock related failure
  * Refresh rust build deps
  * d/control: Specify Rules-Requires-Root: no

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Thu, 15 Oct 2020 16:45:56 +0300
