=== debian/control ===
Source: newsboat
Section: net
Priority: optional
Maintainer: Nikos Tsipinakis <nikos@tsipinakis.com>
Build-Depends: debhelper-compat (= 12),
               libncursesw5-dev,
               libxml2-dev,
               libstfl-dev,
               libsqlite3-dev,
               perl,
               pkg-config,
               libcurl4-gnutls-dev,
               libjson-c-dev,
               asciidoctor,
               cargo,
               librust-chrono-0.4-dev,
               librust-time-0.1-dev,
               librust-rand-0.7-dev,
               librust-once-cell-1+parking-lot-dev,
               librust-regex-1-dev,
               librust-url-2-dev,
               librust-xdg-2-dev,
               librust-backtrace-0.3-dev,
               librust-backtrace-sys-0.1-dev,
               librust-unicode-width-0.1-dev,
               librust-nom-5+lexical-core-dev,
               librust-curl-sys-0.4+ssl-dev,
               librust-libc-0.2-dev,
               librust-gettext-rs-0.4-dev,
               librust-natord-1-dev,
               librust-clap-2-dev,
               librust-gettext-sys-0.19-dev,
               librust-tempfile-3-dev,
               librust-proptest-0.9+bit-set-dev,
               librust-proptest-0.9+rusty-fork-dev,
               librust-proptest-0.9+timeout-dev,
               librust-percent-encoding-2-dev,
               librust-section-testing-0.0.4-dev
Standards-Version: 4.5.0
Homepage: https://www.newsboat.org
Vcs-Git: https://salsa.debian.org/nikos/newsboat.git
Vcs-Browser: https://salsa.debian.org/nikos/newsboat
Rules-Requires-Root: no

Package: newsboat
Architecture: any
Recommends: sensible-utils
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: text mode rss feed reader with podcast support
 newsboat is an RSS/Atom feed reader for the text console. It supports OPML
 import/export, podcasts (via companion program podboat), and can serve as
 a client to various feed aggregators (TT-RSS, The Old Reader, Newsblur,
 FeedHQ, ownCloud/nextCloud News). Its interface draws inspiration from mutt
 and slrn.
 .
 Successor of newsbeuter.
