## newsboat 2.32

=== debian/changelog ===
newsboat (2.32-3) unstable; urgency=medium

  [ Peter Michael Green ]
  * Stop patching lexopt cargo dependency and update Debian dependency
    for lexopt 0.3.

  [ Adrian Bunk ]
  * Use the packaged catch.hpp and json.hpp instead of vendored copies.
    (Closes: #1017137)

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Sun, 30 Jul 2023 11:34:16 +0200

newsboat (2.32-2) unstable; urgency=medium

  * Add missing lexopt, md5 dependencies

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Thu, 29 Jun 2023 21:10:11 +0200

newsboat (2.32-1) unstable; urgency=medium

  [ Nikos Tsipinakis ]
  * New upstream release
  * Update rust deps for 2.32
  * Refresh patches
  * d/rules: Run cargo tests during build
  * Add autopkgtests support for upstream test suite

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Thu, 29 Jun 2023 19:39:17 +0200
