=== debian/control ===
--- 
+++ 
@@ -11,11 +11,18 @@
                pkg-config,
                libcurl4-gnutls-dev,
                libjson-c-dev,
+               catch2,
+               nlohmann-json3-dev,
                asciidoctor,
                cargo,
+               librust-lexopt-0.3-dev,
+               librust-md5-0.7-dev,
+               librust-bitflags-2-dev,
                librust-chrono-0.4-dev,
+               librust-cxx-1-dev,
+               librust-cxx-build-1-dev,
                librust-time-0.1-dev,
-               librust-rand-0.7-dev,
+               librust-rand-0.8-dev,
                librust-once-cell-1+parking-lot-dev,
                librust-regex-1-dev,
                librust-url-2-dev,
@@ -23,17 +30,16 @@
                librust-backtrace-0.3-dev,
                librust-backtrace-sys-0.1-dev,
                librust-unicode-width-0.1-dev,
-               librust-nom-5+lexical-core-dev,
+               librust-nom-7-dev,
                librust-curl-sys-0.4+ssl-dev,
                librust-libc-0.2-dev,
-               librust-gettext-rs-0.4-dev,
+               librust-gettext-rs-0.7-dev,
                librust-natord-1-dev,
-               librust-clap-2-dev,
-               librust-gettext-sys-0.19-dev,
+               librust-gettext-sys-0.21-dev,
                librust-tempfile-3-dev,
-               librust-proptest-0.9+bit-set-dev,
-               librust-proptest-0.9+rusty-fork-dev,
-               librust-proptest-0.9+timeout-dev,
+               librust-proptest-1+bit-set-dev,
+               librust-proptest-1+rusty-fork-dev,
+               librust-proptest-1+timeout-dev,
                librust-percent-encoding-2-dev,
                librust-section-testing-0.0.4-dev
 Standards-Version: 4.5.0
