=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,8 @@
 
 override_dh_auto_build:
 	rm -f Cargo.lock
+	ln -fs /usr/include/catch2/catch.hpp 3rd-party/
+	ln -fs /usr/include/nlohmann/json.hpp 3rd-party/
 	dh_auto_build -- CARGO_HOME=debian/cargo_home prefix=/usr all
 	make doc
 
@@ -24,4 +26,5 @@
 	dh_auto_test -- CARGO_HOME=debian/cargo_home
 ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
 	cd test && LC_ALL=C.UTF-8 TERM=dumb ./test --order rand
+	CARGO_HOME=debian/cargo_home cargo test
 endif
