=== debian/changelog ===
newsboat (2.36-1.2) unstable; urgency=medium

  * Non-maintainer upload
  * Work around Curl 8.16.0 curl_proxytype issue (Closes: #1114221)
  * Build with -Wno-error to prevent FTBFS (Closes: #1033633)

 -- Bastian Germann <bage@debian.org>  Thu, 18 Sep 2025 19:57:55 +0200

newsboat (2.36-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Drop unnecessary B-D rust-time-0.1 (Closes: #1053628)
  * Ignore failing tests (Closes: #1077951)

 -- Bastian Germann <bage@debian.org>  Mon, 02 Dec 2024 20:58:53 +0000

newsboat (2.36-1) unstable; urgency=medium

  * New upstream version 2.36
  * Refresh patches and deps
  * Add patch to update catch to v3
  * Link catch as an external library

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Mon, 29 Jul 2024 08:48:40 +0200
