=== debian/tests/control ===
Tests: suite
Depends: @, @builddeps@
Restrictions: allow-stderr
