=== debian/watch ===
version=4
opts="pgpmode=mangle, pgpsigurlmangle=s/$/.asc/" \
https://newsboat.org \./releases/(?:\d+\.?)+/newsboat-(\d+\.\d+(?:\.\d+)?)\.tar\.xz
