## newsboat 2.38

=== debian/changelog ===
newsboat (2.38-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream version (Closes: #1101191)

 -- Bastian Germann <bage@debian.org>  Sun, 11 Jan 2026 16:14:14 +0100
