=== debian/control ===
--- 
+++ 
@@ -21,7 +21,6 @@
                librust-chrono-0.4-dev,
                librust-cxx-1-dev,
                librust-cxx-build-1-dev,
-               librust-time-0.1-dev,
                librust-rand-0.8-dev,
                librust-once-cell-1+parking-lot-dev,
                librust-regex-1-dev,
@@ -41,7 +40,9 @@
                librust-proptest-1+rusty-fork-dev,
                librust-proptest-1+timeout-dev,
                librust-percent-encoding-2-dev,
-               librust-section-testing-0.0.4-dev
+               librust-section-testing-0.0.4-dev,
+               librust-unicode-segmentation-dev,
+               librust-fastrand-2-dev
 Standards-Version: 4.5.0
 Homepage: https://www.newsboat.org
 Vcs-Git: https://salsa.debian.org/nikos/newsboat.git
